# Soya 3D
# Copyright (C) 2003 Jean-Baptiste LAMY -- jiba@tuxfamily.org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

include "c_opengl.pxd"
include "sdl.pxd"

include "chunk.pxd"
include "definitions/base.pxd"
include "matrix.pxd"
include "definitions/math3d.pxd"
include "definitions/renderer.pxd"
include "definitions/idler.pxd"


include "definitions/soya3d/atmosphere.pxd"
include "definitions/soya3d/raypick.pxd"
include "definitions/soya3d/coordsyst.pxd"
include "definitions/soya3d/volume.pxd"
include "definitions/soya3d/world.pxd"
include "definitions/soya3d/light.pxd"
include "definitions/soya3d/camera.pxd"
include "definitions/soya3d/portal.pxd"
include "definitions/soya3d/traveling_camera.pxd"

include "definitions/model/image.pxd"
include "definitions/model/material.pxd"
include "definitions/model/face.pxd"
include "definitions/model/shape.pxd"
include "definitions/model/cellshading.pxd"
include "definitions/model/tree.pxd"
include "definitions/model/sprite.pxd"
include "definitions/model/particle.pxd"
include "definitions/model/land.pxd"
include "definitions/model/watercube.pxd"
include "definitions/model/shapifier.pxd"

include "cal3d/cal3d.pxd"
include "cal3d/shape.pxd"
include "cal3d/volume.pxd"

include "text/freetype.pxd"
include "text/text.pxd"
